import { PathSegment } from '../../types';
import { EntityKey } from '../resource';
import { SegmentHandler } from './handlers';
export type ODataSegment = {
    name: PathSegment;
    path: string;
    type?: string;
    key?: any;
    parameters?: any;
};
export declare class ODataPathSegments {
    private _segments;
    constructor(segments?: ODataSegment[]);
    pathAndParams(escape?: boolean): [string, {
        [name: string]: any;
    }];
    types({ key }?: {
        key?: boolean;
    }): string[];
    keys(values?: (EntityKey<any> | undefined)[]): (EntityKey<any> | undefined)[];
    toString(): string;
    toJSON(): any[];
    clone(): ODataPathSegments;
    find(predicate: (segment: ODataSegment) => boolean): ODataSegment | undefined;
    segments({ key }?: {
        key?: boolean;
    }): SegmentHandler[];
    first({ key }?: {
        key?: boolean;
    }): SegmentHandler | undefined;
    last({ key }?: {
        key?: boolean;
    }): SegmentHandler | undefined;
    add(name: string, path: string): SegmentHandler;
    get(name: string): SegmentHandler;
}
