import { QueryOption } from '../../types';
import { Expand, Filter, OrderBy, Select, Transform } from './builder';
import { ComputeExpression, Expression, FilterExpression, OrderByExpression, SearchExpression } from './expressions';
import { ExpandExpression } from './expressions/expand';
import { SelectExpression } from './expressions/select';
import { ODataQueryOptionHandler } from './handlers';
export type ODataQueryArguments<T> = {
    [QueryOption.select]?: Select<T> | SelectExpression<T> | null;
    [QueryOption.expand]?: Expand<T> | ExpandExpression<T> | null;
    [QueryOption.compute]?: string | ComputeExpression<T> | null;
    [QueryOption.filter]?: Filter<T> | FilterExpression<T> | null;
    [QueryOption.search]?: string | SearchExpression<T> | null;
    [QueryOption.transform]?: Transform<T> | null;
    [QueryOption.orderBy]?: OrderBy<T> | OrderByExpression<T> | null;
    [QueryOption.top]?: number | null;
    [QueryOption.skip]?: number | null;
    [QueryOption.skiptoken]?: string | null;
    [QueryOption.format]?: string | null;
    [QueryOption.levels]?: number | 'max' | null;
    [QueryOption.count]?: boolean | null;
};
export declare class ODataQueryOptions<T> {
    values: Map<QueryOption, any>;
    constructor(values?: Map<QueryOption, any> | {
        [name: string]: any;
    });
    pathAndParams(escape?: boolean): [string, {
        [name: string]: any;
    }];
    toString(): string;
    toJSON(): {};
    toQueryArguments(): ODataQueryArguments<T>;
    clone<O>(): ODataQueryOptions<O>;
    expression(key: QueryOption, exp?: Expression<T>): any;
    option<O>(key: QueryOption, opts?: O): ODataQueryOptionHandler<O>;
    has(key: QueryOption): boolean;
    remove(...keys: QueryOption[]): void;
    keep(...keys: QueryOption[]): void;
    clear(): void;
}
