export declare class CsdlFunction {
    name: string;
    returnType: CsdlReturnType;
    isBound?: boolean | undefined;
    entitySetPath?: string | undefined;
    isComposable?: boolean | undefined;
    parameters?: CsdlParameter[] | undefined;
    constructor(name: string, returnType: CsdlReturnType, isBound?: boolean | undefined, entitySetPath?: string | undefined, isComposable?: boolean | undefined, parameters?: CsdlParameter[] | undefined);
}
export declare class CsdlAction {
    name: string;
    returnType?: CsdlReturnType | undefined;
    isBound?: boolean | undefined;
    entitySetPath?: string | undefined;
    parameters?: CsdlParameter[] | undefined;
    constructor(name: string, returnType?: CsdlReturnType | undefined, isBound?: boolean | undefined, entitySetPath?: string | undefined, parameters?: CsdlParameter[] | undefined);
}
export declare class CsdlFunctionImport {
    name: string;
    functionName: string;
    entitySet?: string | undefined;
    IncludeInServiceDocument?: boolean | undefined;
    constructor(name: string, functionName: string, entitySet?: string | undefined, IncludeInServiceDocument?: boolean | undefined);
}
export declare class CsdlActionImport {
    name: string;
    action: string;
    entitySet?: string | undefined;
    constructor(name: string, action: string, entitySet?: string | undefined);
}
export declare class CsdlParameter {
    name: string;
    type: string;
    nullable?: boolean | undefined;
    maxLength?: number | undefined;
    precision?: number | undefined;
    scale?: number | undefined;
    srid?: string | undefined;
    constructor(name: string, type: string, nullable?: boolean | undefined, maxLength?: number | undefined, precision?: number | undefined, scale?: number | undefined, srid?: string | undefined);
}
export declare class CsdlReturnType {
    type: string;
    nullable?: boolean | undefined;
    maxLength?: number | undefined;
    precision?: number | undefined;
    scale?: number | undefined;
    srid?: string | undefined;
    constructor(type: string, nullable?: boolean | undefined, maxLength?: number | undefined, precision?: number | undefined, scale?: number | undefined, srid?: string | undefined);
}
