export declare abstract class CsdlStructuralProperty {
    name: string;
    type: string;
    nullable?: boolean | undefined;
    constructor(name: string, type: string, nullable?: boolean | undefined);
}
export declare class CsdlProperty extends CsdlStructuralProperty {
    maxLength?: number | undefined;
    precision?: number | undefined;
    scale?: number | undefined;
    unicode?: boolean | undefined;
    srid?: string | undefined;
    defaultValue?: string | undefined;
    constructor(name: string, type: string, nullable?: boolean, maxLength?: number | undefined, precision?: number | undefined, scale?: number | undefined, unicode?: boolean | undefined, srid?: string | undefined, defaultValue?: string | undefined);
}
export declare class CsdlNavigationProperty extends CsdlStructuralProperty {
    partner?: string | undefined;
    containsTarget?: boolean | undefined;
    referentialConstraints?: CsdlReferentialConstraint[] | undefined;
    onDelete?: CsdlOnDelete | undefined;
    constructor(name: string, type: string, nullable?: boolean, partner?: string | undefined, containsTarget?: boolean | undefined, referentialConstraints?: CsdlReferentialConstraint[] | undefined, onDelete?: CsdlOnDelete | undefined);
}
export declare class CsdlReferentialConstraint {
    property: string;
    referencedProperty: string;
    constructor(property: string, referencedProperty: string);
}
export declare class CsdlOnDelete {
    action: string;
    constructor(action: string);
}
