import { CsdlProperty, CsdlNavigationProperty } from './csdl-structural-property';
export declare class CsdlStructuredType {
    name: string;
    properties?: CsdlProperty[] | undefined;
    navigationProperties?: CsdlNavigationProperty[] | undefined;
    baseType?: string | undefined;
    openType?: boolean | undefined;
    abstract?: boolean | undefined;
    constructor(name: string, properties?: CsdlProperty[] | undefined, navigationProperties?: CsdlNavigationProperty[] | undefined, baseType?: string | undefined, openType?: boolean | undefined, abstract?: boolean | undefined);
}
export declare class CsdlComplexType extends CsdlStructuredType {
    constructor(name: string, properties?: CsdlProperty[], navigationProperties?: CsdlNavigationProperty[], baseType?: string, openType?: boolean, abstract?: boolean);
}
export declare class CsdlEntityType extends CsdlStructuredType {
    key?: CsdlKey | undefined;
    hasStream?: boolean | undefined;
    constructor(name: string, key?: CsdlKey | undefined, properties?: CsdlProperty[], navigationProperties?: CsdlNavigationProperty[], baseType?: string, openType?: boolean, abstract?: boolean, hasStream?: boolean | undefined);
}
export declare class CsdlKey {
    propertyRefs: CsdlPropertyRef[];
    constructor(propertyRefs: CsdlPropertyRef[]);
}
export declare class CsdlPropertyRef {
    name: string;
    alias?: string | undefined;
    constructor(name: string, alias?: string | undefined);
}
