import { ODataMetadataType, ODataVersion, ParserOptions, ResponseOptions } from '../../types';
export declare class ODataResponseOptions implements ResponseOptions {
    version: ODataVersion;
    streaming?: boolean;
    metadata?: ODataMetadataType;
    ieee754Compatible?: boolean;
    location?: string;
    cacheability?: 'public' | 'private' | 'no-cache' | 'no-store';
    maxAge?: number;
    constructor(config: ParserOptions);
    get helper(): import("../../helper").ODataVersionHelper;
    clone(): ODataResponseOptions;
    setFeatures(features: string): void;
    setVersion(version: string): void;
    setLocation(location: string): void;
    setPreferenceApplied(preference: string): void;
    setCache(cacheControl: string): void;
}
