import { Observable } from 'rxjs';
import { ODataApi } from '../../api';
import { ODataPathSegments } from '../path';
import { ODataQueryOptions } from '../query';
import { ODataResource } from '../resource';
import { ODataOptions } from './options';
export declare class ODataCountResource<T> extends ODataResource<T> {
    static factory<T>(api: ODataApi, { segments, query, }: {
        segments: ODataPathSegments;
        query?: ODataQueryOptions<T>;
    }): ODataCountResource<T>;
    clone(): ODataCountResource<T>;
    protected get(options?: ODataOptions): Observable<any>;
    /**
     * Fetch the count of the set.
     * @param options Options for the request
     * @returns The count of the set
     */
    fetch(options?: ODataOptions): Observable<number>;
}
