import { Observable } from 'rxjs';
import { ODataApi } from '../../api';
import { ODataStructuredType } from '../../schema/structured-type';
import { ODataPathSegments } from '../path';
import { ODataQueryOptions } from '../query';
import { ODataResource } from '../resource';
import { ODataOptions } from './options';
export declare class ODataValueResource<T> extends ODataResource<T> {
    static factory<V>(api: ODataApi, { type, schema, segments, query, }: {
        type?: string;
        schema?: ODataStructuredType<V>;
        segments: ODataPathSegments;
        query?: ODataQueryOptions<V>;
    }): ODataValueResource<V>;
    clone(): ODataValueResource<T>;
    protected get(options?: ODataOptions): Observable<T>;
    /**
     * Fetch the value of the resource.
     * @param options OData options.
     * @returns Observable of the value.
     */
    fetch(options?: ODataOptions): Observable<T>;
}
