import { ODataApi } from '../api';
import { Parser, ParserOptions, SchemaConfig } from '../types';
import { ODataAnnotatable } from './annotation';
import { ODataCallable } from './callable';
import { ODataEntityContainer } from './entity-container';
import { ODataEntitySet } from './entity-set';
import { ODataEnumType } from './enum-type';
import { ODataStructuredType } from './structured-type';
export declare class ODataSchema extends ODataAnnotatable {
    api: ODataApi;
    namespace: string;
    alias?: string;
    enums: ODataEnumType<any>[];
    entities: ODataStructuredType<any>[];
    callables: ODataCallable<any>[];
    containers: ODataEntityContainer[];
    constructor(config: SchemaConfig, api: ODataApi);
    isNamespaceOf(type: string): boolean | "" | undefined;
    get entitySets(): ODataEntitySet[];
    findEnumTypeForType<T>(type: string): ODataEnumType<T> | undefined;
    findStructuredTypeForType<T>(type: string): ODataStructuredType<T> | undefined;
    findCallableForType<T>(type: string, bindingType?: string): ODataCallable<T> | undefined;
    findEntitySetForType(type: string): ODataEntitySet | undefined;
    configure({ options, parserForType, findOptionsForType, }: {
        options: ParserOptions;
        parserForType: (type: string) => Parser<any>;
        findOptionsForType: (type: string) => any;
    }): void;
}
