import { Observable } from 'rxjs';
import { ODataApi } from './api';
import { ODataCollection, ODataModel } from './models';
import { ODataRequest } from './resources';
import { ODataCallable, ODataEntitySet, ODataEnumType, ODataStructuredType } from './schema';
import { ODataEntityService } from './services/entity';
import { ApiConfig, EdmType, Parser } from './types';
export declare class ODataSettings {
    apis: ODataApi[];
    constructor(configs: ApiConfig[]);
    configure(settings: {
        requester?: (request: ODataRequest<any>) => Observable<any>;
    }): void;
    defaultApi(): ODataApi;
    findApiByName(name: string): ODataApi | undefined;
    apiByName(name: string): ODataApi;
    findApiForTypes(types: string[]): ODataApi | undefined;
    findApiForType(type: string): ODataApi | undefined;
    apiForType(type: string): ODataApi;
    enumTypeForType<T>(type: string): ODataEnumType<T>;
    structuredTypeForType<T>(type: string): ODataStructuredType<T>;
    callableForType<T>(type: string, bindingType?: string): ODataCallable<T>;
    entitySetForType(type: string): ODataEntitySet;
    parserForType<T>(type: string | EdmType): Parser<T>;
    modelForType(type: string): typeof ODataModel;
    collectionForType(type: string): typeof ODataCollection;
    serviceForType(type: string): typeof ODataEntityService;
    serviceForEntityType(type: string): typeof ODataEntityService;
    enumTypeByName<T>(name: string): ODataEnumType<T>;
    structuredTypeByName<T>(name: string): ODataStructuredType<T>;
    callableByName<T>(name: string, bindingType?: string): ODataCallable<T>;
    entitySetByName(name: string): ODataEntitySet;
    modelByName(name: string): typeof ODataModel;
    collectionByName(name: string): typeof ODataCollection;
    serviceByName(name: string): typeof ODataEntityService;
}
